#!/usr/bin/perl -w
#
# mkpres
# 10/25/00 mkf
#
# mkpres.pl <present-desc> <tmplfile>
#

$BASENAME= "present";

if (2 != @ARGV) {
	print STDERR "USAGE: $0 <present> <tmplfile>\n";
	exit (-1);
}

open (PRESENT, "<".$ARGV[0]) || die "Can't open present";
open (TMPL, "<".$ARGV[1]) || die "Can't open tmpl";

$tmpl = join ("", <TMPL>);

close (TMPL);

$curslide = -1;
@slideinfo = ();
undef ($cursect);

while (<PRESENT>) {
	next if (/^\s*(#|$)/);

	chomp;
	
	if (/^\@SLIDE/) {
		$curslide++;
		$cursect = "";
		push (@slideinfo, {});
	} else {
		if (/^\@\/([^\s]+)$/) {
			undef ($cursect);
		} elsif (/^\@([^\s]+)$/) {
			$cursect = $1;
			${$slideinfo[$curslide]}{$cursect} = "";		
		} elsif (/^\@([^\s]+)\s*(.*)/) {
			${$slideinfo[$curslide]}{$1} = $2;		
		} else {
			${$slideinfo[$curslide]}{$cursect} .= $_;		
		}
	}
}

$i = 1;
foreach $slide (@slideinfo) {
	print "Slide $i\n";
	$tmpl_copy = $tmpl;

	$fname = sprintf "$BASENAME-%03d.html", $i;
	$prev_fname = sprintf "$BASENAME-%03d.html", ($i-1);
	$next_fname = sprintf "$BASENAME-%03d.html", ($i+1);

	if ($i == 1) {
		$nav = "Previous | <a href=\"$next_fname\">Next</a>";
	} elsif ($i < @slideinfo ) {
		$nav = "<a href=\"$prev_fname\">Previous</a> | <a href=\"$next_fname\">Next</a>";
	} else {
		$nav = "<a href=\"$prev_fname\">Previous</a> | Next";
	}

	$tmpl_copy =~ s/\@\@NEXTPREV\@\@/$nav/g;

	foreach $key (keys(%$slide)) {
#		print "\t$key --> ". $${slide{$key}} . "\n";

		$tmpl_copy =~ s/\@\@$key\@\@/$${slide{$key}}/g;
	}

	open (OUTFILE, ">$fname") || die "can't open $fname";

	print OUTFILE $tmpl_copy;
	close (OUTFILE);
	$i++;
}
